## mupen64plus-core 2.5.9+341+gf82b37bf

=== projects/unix/Makefile ===
#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
# *   Mupen64plus - Makefile                                                *
# *   Mupen64Plus homepage: https://mupen64plus.org/                        *
# *   Copyright (C) 2008-2009 Richard Goedeken                              *
# *   Copyright (C) 2007-2008 DarkJeztr Tillin9                             *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
# Makefile for Mupen64Plus Core

# detect operating system
UNAME ?= $(shell uname -s)
OS := NONE
ifeq ("$(UNAME)","Linux")
  OS = LINUX
endif
ifeq ("$(UNAME)","linux")
  OS = LINUX
endif
ifneq ("$(filter GNU hurd,$(UNAME))","")
  OS = LINUX
endif
ifeq ("$(UNAME)","Darwin")
  OS = OSX
endif
ifeq ("$(UNAME)","FreeBSD")
  OS = FREEBSD
endif
ifeq ("$(UNAME)","OpenBSD")
  OS = FREEBSD
  CFLAGS += -DIOAPI_NO_64
endif
ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
  OS = LINUX
endif
ifeq ("$(patsubst MINGW%,MINGW,$(UNAME))","MINGW")
  OS = MINGW
  PIC = 0
endif
ifeq ("$(OS)","NONE")
  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'https://github.com/mupen64plus/mupen64plus-core/issues')
endif

# detect system architecture
HOST_CPU ?= $(shell uname -m)
CPU := NONE
ifneq ("$(filter x86_64 amd64,$(HOST_CPU))","")
  CPU := X86
  ifeq ("$(BITS)", "32")
    ARCH_DETECTED := 64BITS_32
    PIC ?= 0
  else
    ARCH_DETECTED := 64BITS
    PIC ?= 1
  endif
endif
ifneq ("$(filter pentium i%86,$(HOST_CPU))","")
  CPU := X86
  ARCH_DETECTED := 32BITS
  PIC ?= 0
endif
ifneq ("$(filter ppc macppc socppc powerpc,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 32BITS
  BIG_ENDIAN := 1
  PIC ?= 1
  NO_ASM := 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.)
endif
ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 64BITS
  BIG_ENDIAN := 1
  PIC ?= 1
  NO_ASM := 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.)
endif
ifneq ("$(filter ppc64le powerpc64le,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 64BITS
  BIG_ENDIAN := 0
  PIC ?= 1
  NO_ASM := 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.)
endif
ifneq ("$(filter arm%,$(HOST_CPU))","")
  ifeq ("$(filter arm%b,$(HOST_CPU))","")
    CPU := ARM
    PIC ?= 1
    NEW_DYNAREC := 1
    ifneq ("$(filter arm64,$(HOST_CPU))","")
      ARCH_DETECTED := 64BITS
      $(warning Architecture "$(HOST_CPU)" not officially supported.)
    else
      ARCH_DETECTED := 32BITS
      CFLAGS += -marm
      ifneq ("$(filter armv5%,$(HOST_CPU))","")
          CFLAGS += -DARMv5_ONLY
          $(warning Using ARMv5_ONLY)
      endif
      ifneq ("$(filter armv6%,$(HOST_CPU))","")
          CFLAGS += -DARMv5_ONLY
          $(warning Using ARMv5_ONLY)
      endif
      ifeq ($(NEON), 1)
          CFLAGS += -mfpu=neon -mfloat-abi=hard
      else
        ifeq ($(VFP_HARD), 1)
          CFLAGS += -mfpu=vfp -mfloat-abi=hard
        else
          CFLAGS += -mfpu=vfp -mfloat-abi=softfp
        endif
      endif
    endif
  endif
endif
ifneq ("$(filter mips,$(HOST_CPU))","")
  CPU := MIPS
  ARCH_DETECTED := 32BITS
  PIC ?= 1
  NO_ASM := 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.)
endif
ifneq ("$(filter aarch64,$(HOST_CPU))","")
    CPU := ARM
    ARCH_DETECTED := 64BITS
    PIC ?= 1
    NEW_DYNAREC := 1
endif
ifneq ("$(filter riscv64,$(HOST_CPU))","")
    CPU := RISCV64
    ARCH_DETECTED := 64BITS
    PIC ?= 1
    NO_ASM := 1
    $(warning Architecture "$(HOST_CPU)" not officially supported.)
endif
ifeq ("$(CPU)","NONE")
  $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'https://github.com/mupen64plus/mupen64plus-core/issues')
endif

# directory paths
SRCDIR = ../../src
OBJDIR = _obj$(POSTFIX)
SUBDIR = ../../subprojects

# base CFLAGS, LDLIBS, and LDFLAGS
OPTFLAGS ?= -O3 -flto
WARNFLAGS ?= -Wall
CFLAGS += -fno-strict-aliasing -fvisibility=hidden -I$(SRCDIR) -I$(SRCDIR)/asm_defines -DM64P_PARALLEL
CXXFLAGS += -fvisibility-inlines-hidden
LDLIBS +=  -lm

# Since we are building a shared library, we must compile with -fPIC on some architectures
# On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
ifeq ($(PIC), 1)
  CFLAGS += -fPIC
else
  CFLAGS += -fno-PIC
endif

ifeq ($(BIG_ENDIAN), 1)
  CFLAGS += -DM64P_BIG_ENDIAN
endif

# tweak flags for 32-bit build on 64-bit system
ifeq ($(ARCH_DETECTED), 64BITS_32)
  ifeq ($(OS), FREEBSD)
    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
  endif
  ifneq ($(OS), OSX)
    ifeq ($(OS), MINGW)
      LDFLAGS += -Wl,-m,i386pe
    else
      CFLAGS += -m32
      LDFLAGS += -Wl,-m,elf_i386
    endif
  endif
endif

ifeq ($(ARCH_DETECTED), 64BITS)
  ifeq ($(OS), MINGW)
    LDFLAGS += -Wl,-m,i386pep
  endif
endif

# set special flags per-system
ifeq ($(OS), FREEBSD)
  TARGET = libmupen64plus$(POSTFIX).so.2.0.0
  SONAME = libmupen64plus$(POSTFIX).so.2
  LDFLAGS += -Wl,-Bsymbolic -shared -Wl,-export-dynamic -Wl,-soname,$(SONAME)
  LDLIBS += -L${LOCALBASE}/lib -lc
  ifeq ($(ARCH_DETECTED), 64BITS)
    ASFLAGS = -f elf64
  else
    ASFLAGS = -f elf
  endif
endif
ifeq ($(OS), LINUX)
  TARGET = libmupen64plus$(POSTFIX).so.2.0.0
  SONAME = libmupen64plus$(POSTFIX).so.2
  LDFLAGS += -Wl,-Bsymbolic -shared -Wl,-export-dynamic -Wl,-soname,$(SONAME)
  LDLIBS += -ldl
  # only export api symbols
  LDFLAGS += -Wl,-version-script,$(SRCDIR)/api/api_export.ver
  ifeq ($(ARCH_DETECTED), 64BITS)
    ASFLAGS = -f elf64
  else
    ASFLAGS = -f elf
  endif
endif
ifeq ($(OS), OSX)
  OSX_SDK_PATH = $(shell xcrun --sdk macosx --show-sdk-path)

  TARGET = libmupen64plus$(POSTFIX).dylib
  LDFLAGS += -framework CoreFoundation -dynamiclib
  LDLIBS += -ldl
  ifeq ($(ARCH_DETECTED), 64BITS)
    ASFLAGS = -f macho64 -d LEADING_UNDERSCORE
  else
    ASFLAGS = -f macho -d LEADING_UNDERSCORE
  endif

  CXXFLAGS += '-stdlib=libc++'
  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.7 -isysroot $(OSX_SDK_PATH)
    else
      CFLAGS += -pipe -mmmx -msse -arch i686 -mmacosx-version-min=10.7 -isysroot $(OSX_SDK_PATH)
      ifneq ($(PROFILE), 1)
        CFLAGS += -fomit-frame-pointer
      endif
	  LDFLAGS += -read_only_relocs suppress
    endif
  endif
  ifeq ($(CPU), ARM)
    # assembly compilation not yet supported on macOS with Apple Silicon
    NO_ASM = 1
    CFLAGS += -pipe -arch arm64 -mmacosx-version-min=10.16 -isysroot $(OSX_SDK_PATH)
  endif
endif
ifeq ($(OS), MINGW)
  TARGET = mupen64plus$(POSTFIX).dll
  ifeq ($(CC), clang)
    LDFLAGS += -shared -Wl,-export-all-symbols
  else
    LDFLAGS += -Wl,-Bsymbolic -shared -Wl,-export-all-symbols
    # only export api symbols
    LDFLAGS += -Wl,-version-script,$(SRCDIR)/api/api_export.ver
  endif
  LDLIBS += -lpthread
  ifeq ($(ARCH_DETECTED), 64BITS)
    ASFLAGS = -f win64 -d WIN64
  else
    ASFLAGS = -f win32 -d LEADING_UNDERSCORE
  endif
endif

ifeq ($(PIC), 1)
  ASFLAGS += -d PIC
endif

# assembler also needs base include directories
ASFLAGS += -I$(SRCDIR) -I$(SRCDIR)/asm_defines/

ifeq ($(CPU_ENDIANNESS), BIG)
  CFLAGS += -DM64P_BIG_ENDIAN
endif

# disable verbose output
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
    Q_CC  = @echo '    CC  '$@;
    Q_CXX = @echo '    CXX '$@;
    Q_AS  = @echo '    AS  '$@;
    Q_LD  = @echo '    LD  '$@;
endif
endif

# test for essential build dependencies
ifeq ($(origin PKG_CONFIG), undefined)
  PKG_CONFIG = $(CROSS_COMPILE)pkg-config
  ifeq ($(shell which $(PKG_CONFIG) 2>/dev/null),)
    $(error $(PKG_CONFIG) not found)
  endif
endif

ifeq ($(OS), OSX) # use system zlib on OSX
  ZLIB_LDLIBS += -lz
endif

ifeq ($(origin ZLIB_CFLAGS) $(origin ZLIB_LDLIBS), undefined undefined)
  ifeq ($(shell $(PKG_CONFIG) --modversion zlib 2>/dev/null),)
    $(error No zlib development libraries found!)
  endif
  ZLIB_CFLAGS += $(shell $(PKG_CONFIG) --cflags zlib)
  ZLIB_LDLIBS +=  $(shell $(PKG_CONFIG) --libs zlib)
endif
CFLAGS += $(ZLIB_CFLAGS)
LDLIBS += $(ZLIB_LDLIBS)

ifeq ($(origin MINIZIP_CFLAGS) $(origin MINIZIP_LDLIBS), undefined undefined)
  ifeq ($(shell $(PKG_CONFIG) --modversion minizip 2>/dev/null),)
    CFLAGS += -DNOCRYPT -DNOUNCRYPT -I$(SUBDIR)/minizip
    MINIZIP_SOURCE = \
      $(SUBDIR)/minizip/ioapi.c \
      $(SUBDIR)/minizip/zip.c \
      $(SUBDIR)/minizip/unzip.c
  else
    MINIZIP_CFLAGS = $(shell $(PKG_CONFIG) --cflags minizip)
    MINIZIP_LDLIBS =  $(shell $(PKG_CONFIG) --libs minizip)
  endif
endif
CFLAGS += $(MINIZIP_CFLAGS)
LDLIBS += $(MINIZIP_LDLIBS)

ifeq ($(origin LIBPNG_CFLAGS) $(origin LIBPNG_LDLIBS), undefined undefined)
  ifeq ($(shell $(PKG_CONFIG) --modversion libpng 2>/dev/null),)
    $(error No libpng development libraries found!)
  endif
  LIBPNG_CFLAGS += $(shell $(PKG_CONFIG) --cflags libpng)
  LIBPNG_LDLIBS +=  $(shell $(PKG_CONFIG) --libs libpng)
endif
CFLAGS += $(LIBPNG_CFLAGS)
LDLIBS += $(LIBPNG_LDLIBS)

ifeq ($(OPENCV), 1)
  # OpenCV lib
  ifeq ($(origin OPENCV_CFLAGS) $(origin OPENCV_LDLIBS), undefined undefined)
    ifeq ($(shell $(PKG_CONFIG) --modversion opencv 2>/dev/null),)
      $(error No OpenCV development libraries found!)
    endif
    OPENCV_CFLAGS += $(shell $(PKG_CONFIG) --cflags opencv)
    OPENCV_LDLIBS += $(shell $(PKG_CONFIG) --libs opencv)
  endif
  CFLAGS += $(OPENCV_CFLAGS)
  LDLIBS += $(OPENCV_LDLIBS)
endif

# test for presence of SDL
ifeq ($(origin SDL_CFLAGS) $(origin SDL_LDLIBS), undefined undefined)
  SDL_CONFIG = $(CROSS_COMPILE)sdl2-config
  ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
    SDL_CONFIG = $(CROSS_COMPILE)sdl-config
    ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
      $(error No SDL development libraries found!)
    else
      ifeq ($(NETPLAY), 1)
        SDL_LDLIBS += -lSDL_net
      endif
      $(warning Using SDL 1.2 libraries)
    endif
  else
    ifeq ($(NETPLAY), 1)
      SDL_LDLIBS += -lSDL2_net
    endif
  endif
  SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
  SDL_LDLIBS += $(shell $(SDL_CONFIG) --libs)
endif
CFLAGS += $(SDL_CFLAGS)
LDLIBS += $(SDL_LDLIBS)

ifeq ($(VC), 1)
  CFLAGS += -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/vmcs_host/linux
  LDLIBS += -L/opt/vc/lib -lbrcmEGL -lbcm_host -lvcos -lvchiq_arm
  GLES_LIB := -lbrcmGLESv2
  USE_GLES := 1
endif

ifeq ($(USE_GLES), 1)
  GLES_LIB ?= -lGLESv2
  CFLAGS += -DUSE_GLES
  LDLIBS += $(GLES_LIB)
  # OSD uses non-ES code and breaks attribs of video plugins
  OSD=0
endif

OSD ?= 1
ifeq ($(OSD), 1)
  CFLAGS += -DM64P_OSD

  ifeq ($(origin FREETYPE2_CFLAGS) $(origin FREETYPE2_LDLIBS), undefined undefined)
    ifeq ($(shell $(PKG_CONFIG) --modversion freetype2 2>/dev/null),)
      $(error No freetype2 development libraries found!)
    endif

=== debian/changelog ===
mupen64plus-core (2.5.9+341+gf82b37bf-1) unstable; urgency=medium

  * New Upstream Snapshot from f82b37bf63066190e2b41d74deb17846af017a90

 -- Sven Eckelmann <sven@narfation.org>  Wed, 01 Feb 2023 20:36:58 +0100

mupen64plus-core (2.5.9+332+gba9a5248-2) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.6.2, no changes required
  * debian/patches:
    - Add Don-t-print-recomp-interpreter-debug-info-when-debugger-i.patch,
      Don't print recomp/interpreter debug info when debugger is enabled

 -- Sven Eckelmann <sven@narfation.org>  Sat, 31 Dec 2022 19:25:39 +0100

mupen64plus-core (2.5.9+332+gba9a5248-1) unstable; urgency=medium

  * Upload to unstable
  * New Upstream Snapshot from ba9a52483052248b67c324e3fd0e073b807bbea4
  * debian/rules:
    - disallow compiler to drop code related to signed integer overflows during
      optimization

 -- Sven Eckelmann <sven@narfation.org>  Fri, 16 Dec 2022 21:17:14 +0100

mupen64plus-core (2.5.9+322+g2ac8682c-1) experimental; urgency=medium

  * New Upstream Snapshot from 2ac8682c60e7df3581b9167fa67d47e263d2b9da

 -- Sven Eckelmann <sven@narfation.org>  Tue, 15 Nov 2022 17:53:12 +0100

mupen64plus-core (2.5.9-4) unstable; urgency=medium

  * Upload to unstable

 -- Sven Eckelmann <sven@narfation.org>  Tue, 15 Nov 2022 15:09:28 +0100

mupen64plus-core (2.5.9-3) experimental; urgency=medium

  * debian/patches:
    - Add Fix-multiple-definition-errors.patch,
      Fix FTBFS with GCC 10 (Closes: #966344)

 -- Sven Eckelmann <sven@narfation.org>  Mon, 27 Jul 2020 18:12:27 +0200

mupen64plus-core (2.5.9-2) experimental; urgency=medium

  * Upgraded to policy 4.4.1, no changes required
  * debian/patches:
    - Add Build-against-libopencv4.patch, Fix FTBFS against libopencv >= 4
      (Closes: #944668)
  * debian/control:
    - Allow build without (fake)root

 -- Sven Eckelmann <sven@narfation.org>  Thu, 14 Nov 2019 21:11:53 +0100

mupen64plus-core (2.5-10) unstable; urgency=medium

  * debian/control:
    - Remove constraints unnecessary since buster (oldstable):
      + libmupen64plus2: Drop versioned constraint on
        mupen64plus-(audio|input|video)-* in Breaks and Replaces.
      + mupen64plus-data: Drop versioned constraint on
        libmupen64plus2 + mupen64plus in Breaks and Replaces.
    - Replace Build-Depends libfreetype6-dev with libfreetype-dev
    - Replace Build-Depends libgl1-mesa-dev with libgl-dev
    - Upgraded to policy 4.6.1, no changes required
  * debian/copyright:
    - Update copyright years to 2022

 -- Sven Eckelmann <sven@narfation.org>  Mon, 14 Nov 2022 18:50:07 +0100

mupen64plus-core (2.5-9) unstable; urgency=medium

  * debian/control:
    - Remove versioned constraints unnecessary since buster
    - Use secure URI in Homepage field
  * debian/patches:
    - Add Fix-wrong-pitch-argument-in-call-to-SDL_CreateRGBSurfaceF.patch,
      Fix wrong pitch argument in call to
      SDL_CreateRGBSurfaceFrom (Closes: #1021748)

 -- Sven Eckelmann <sven@narfation.org>  Fri, 14 Oct 2022 08:35:33 +0200

=== debian/control ===
Source: mupen64plus-core
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sven Eckelmann <sven@narfation.org>,
 Tobias Loose <TobiasLoose@gmx.de>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://mupen64plus.org/
Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-core.git -b debian/unstable
Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-core
Build-Depends:
 debhelper-compat (= 13),
 libfreetype-dev,
 libgl-dev [any-i386 any-amd64],
 libglu1-mesa-dev [any-i386 any-amd64] | libglu-dev [any-i386 any-amd64],
 libminizip-dev,
 libopencv-dev (>= 4),
 libpng-dev,
 libsdl2-dev,
 libsdl2-net-dev,
 nasm,
 pkg-config,
 zlib1g-dev | libz-dev,

Package: libmupen64plus-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: mupen64plus development package
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 This package contains everything which is needed to build plugins or frontends
 against the mupen64plus API.

Package: libmupen64plus2
Section: libs
Architecture: any-amd64 any-i386
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 mupen64plus-data,
 fonts-dejavu-core,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 mupen64plus-audio-abi-2,
 mupen64plus-config-abi-2.2,
 mupen64plus-config-abi-2.3,
 mupen64plus-config-abi-2.3.1,
 mupen64plus-config-abi-2.3.2,
 mupen64plus-debug-abi-2,
 mupen64plus-debug-abi-2.0.1,
 mupen64plus-frontend-abi-2.1.1,
 mupen64plus-frontend-abi-2.1.2,
 mupen64plus-frontend-abi-2.1.3,
 mupen64plus-frontend-abi-2.1.4,
 mupen64plus-gfx-abi-2.1,
 mupen64plus-gfx-abi-2.2,
 mupen64plus-input-abi-2.1,
 mupen64plus-input-abi-2.1.1,
 mupen64plus-netplay-abi-1.0.1,
 mupen64plus-rsp-abi-2,
 mupen64plus-vidext-abi-3,
 mupen64plus-vidext-abi-3.1,
 mupen64plus-vidext-abi-3.2,
Description: plugin-based Nintendo 64 emulator, core library
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 It has the following features:
  * cheat system
  * exchangeable plugins for graphics, sound and input emulation
  * multiple save states
  * common configuration system for all components
 .
 This package contains the actual emulator which must be loaded by a frontend.

Package: mupen64plus-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 libmupen64plus2 (<< 1.99.5-3),
 mupen64plus (<< 1.99.1),
Replaces:
 libmupen64plus2 (<< 1.99.5-3),
 mupen64plus (<< 1.99.1),
Description: plugin-based Nintendo 64 emulator, data files
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 It has the following features:
  * cheat system
  * exchangeable plugins for graphics, sound and input emulation
  * multiple save states
  * common configuration system for all components
 .
 This package contains the rom catalog and cheat database.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildtools.mk

export PKG_CONFIG ?= pkg-config
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND=-flto
export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# mupen64plus and its plugins sometimes use signed integer overflows
# the compiler must not optimize them away due to their "undefined behavior"
DEB_CFLAGS_MAINT_APPEND=-fno-aggressive-loop-optimizations -fno-strict-overflow

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 DEBUGGER=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" SHAREDIR="/usr/share/games/mupen64plus/" SDL_CONFIG=sdl2-config OPENCV=1 NETPLAY=1

ifeq ($(DEB_HOST_ARCH),armhf)
MAKEOPTIONS += USE_GLES=1 NEON=1
endif

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix"

override_dh_auto_test:
	# otherwise dh_auto_test fails with debhelper 9.20130624

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_clean override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_installchangelogs

## mupen64plus-core 2.6.0

=== projects/unix/Makefile ===
--- 
+++ 
@@ -236,9 +236,9 @@
   CXXFLAGS += '-stdlib=libc++'
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.7 -isysroot $(OSX_SDK_PATH)
+      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.9 -isysroot $(OSX_SDK_PATH)
     else
-      CFLAGS += -pipe -mmmx -msse -arch i686 -mmacosx-version-min=10.7 -isysroot $(OSX_SDK_PATH)
+      CFLAGS += -pipe -mmmx -msse -arch i686 -mmacosx-version-min=10.9 -isysroot $(OSX_SDK_PATH)
       ifneq ($(PROFILE), 1)
         CFLAGS += -fomit-frame-pointer
       endif
@@ -360,6 +360,8 @@
       ifeq ($(NETPLAY), 1)
         SDL_LDLIBS += -lSDL_net
       endif
+      # SDL1 doesn't support vulkan
+      VULKAN = 0
       $(warning Using SDL 1.2 libraries)
     endif
   else
@@ -394,5 +396,3 @@
 
   ifeq ($(origin FREETYPE2_CFLAGS) $(origin FREETYPE2_LDLIBS), undefined undefined)
     ifeq ($(shell $(PKG_CONFIG) --modversion freetype2 2>/dev/null),)
-      $(error No freetype2 development libraries found!)
-    endif

=== debian/changelog ===
mupen64plus-core (2.6.0-2) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.7.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 01 Mar 2025 20:57:54 +0100

mupen64plus-core (2.6.0-1) unstable; urgency=medium

  * New Upstream Version
  * debian/rules:
    - Use DEB_BUILD_MAINT_OPTIONS to set lto flags
    - Use DEB_BUILD_MAINT_OPTIONS to set lfs flag
  * debian/control:
    - Replace pkg-config with pkgconf
    - Depend on libvulkan-dev for vulkan video extensions
    - Provide new ABI versions
      + mupen64plus-frontend-abi-2.1.5
      + mupen64plus-frontend-abi-2.1.6
      * mupen64plus-vidext-abi-3.3
  * debian/watch:
    - Switch to api.github.com to check for releases

 -- Sven Eckelmann <sven@narfation.org>  Mon, 15 Jul 2024 11:49:07 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Sven Eckelmann <sven@narfation.org>,
  Tobias Loose <TobiasLoose@gmx.de>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://mupen64plus.org/
 Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-core.git -b debian/unstable
@@ -20,8 +20,9 @@
  libpng-dev,
  libsdl2-dev,
  libsdl2-net-dev,
+ libvulkan-dev,
  nasm,
- pkg-config,
+ pkgconf,
  zlib1g-dev | libz-dev,
 
 Package: libmupen64plus-dev
@@ -62,6 +63,8 @@
  mupen64plus-frontend-abi-2.1.2,
  mupen64plus-frontend-abi-2.1.3,
  mupen64plus-frontend-abi-2.1.4,
+ mupen64plus-frontend-abi-2.1.5,
+ mupen64plus-frontend-abi-2.1.6,
  mupen64plus-gfx-abi-2.1,
  mupen64plus-gfx-abi-2.2,
  mupen64plus-input-abi-2.1,
@@ -71,6 +74,7 @@
  mupen64plus-vidext-abi-3,
  mupen64plus-vidext-abi-3.1,
  mupen64plus-vidext-abi-3.2,
+ mupen64plus-vidext-abi-3.3,
 Description: plugin-based Nintendo 64 emulator, core library
  Flexible N64 Emulator for Linux that works with many ROMs that are publically
  available. It consists of separate components to provide an user interface,

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,7 @@
 -include /usr/share/dpkg/buildtools.mk
 
 export PKG_CONFIG ?= pkg-config
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
-export DEB_CFLAGS_MAINT_APPEND=-flto
-export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie optimize=+lto abi=+lfs
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 # mupen64plus and its plugins sometimes use signed integer overflows
